/* A simple arrow you can draw wherever in the world you want it to be.
	You can set the thickness and both endpoints.
*/
obj/arrow
	icon_state = "arrow"

	var
		thickness = 32

		vector2
			tail
			head

	proc
		SetThickness(new_thickness)
			thickness = new_thickness
			Draw()

		SetPoints(vector2/tail, vector2/head, z)
			src.tail = tail
			src.head = head
			if(src.z)
				PixelMoveTo(tail)
			else
				SetCenterTo(tail, z)
			Draw()

		Draw()
			var matrix/t
			if(head ~! tail)
				t = line_transform(head - tail, thickness)
			else
				t = matrix(0,0,0, 0,0,0)
			animate(src, time = world.tick_lag,
				flags = ANIMATION_END_NOW | ANIMATION_LINEAR_TRANSFORM,
				transform = t)

