/* Shows how to use events to add side effects to a button tracker.
*/

// Enables right mouse button detection.
client
	show_popup_menus = FALSE

mob
	Login()
		..()
		// Attach the Echo procs to the OnPressed and OnReleased events of
		// client.macros (from the Any Macro library) and
		// client.mouse_buttons (from the Mouse Button Tracking library).
		EVENT_ADD(client.macros.OnPressed, src, .proc/EchoButtonPressed)
		EVENT_ADD(client.macros.OnReleased, src, .proc/EchoButtonReleased)
		EVENT_ADD(client.mouse_buttons.OnPressed, src, .proc/EchoButtonPressed)
		EVENT_ADD(client.mouse_buttons.OnReleased, src, .proc/EchoButtonReleased)

	proc
		// Called when any button is pressed.
		EchoButtonPressed(button_tracker/tracker, button)
			src << "Pressed [button]."

		// Called when any button is released.
		EchoButtonReleased(button_tracker/tracker, button)
			src << "Released [button]."
