/* Shows how to make the player look at the mouse.
*/

#include "../AtomForward.dm"
#include "PlayerLoop.dm"

// Show how opacity doesn't break mouse tracking at all.
// (neither does moving the mouse past the map's edge)
turf/wall/opacity = TRUE

mob/player
	// Arrows show rotation a lot better than a circle does.
	icon_state = "arrow"

	PlayerUpdate()
		..()
		// Get a vector from the player to the mouse.
		var vector2/to_mouse = client.mouse_position.WorldPosition() - CenterPosition()
		// Only look at the mouse if there's an actual direction to it.
		if(to_mouse ~! Vector2.Zero)
			// Rotate to point at the mouse.
			SetForward(to_mouse)
