/* Right click to set a destination to move towards until you reach it.
*/

#include "../Arrow.dm"
#include "PlayerMoveSpeed.dm"

client
	// The right mouse button can only be detected when popup menus are disabled.
	show_popup_menus = FALSE

mob/player
	var
		tmp
			moving = FALSE // Is currently moving? Prevents loop stacking.
			vector2/move_target // Where we're currently moving to.
			obj/arrow/move_arrow

	Login()
		..()
		move_arrow = new
		move_arrow.color = "red"
		move_arrow.SetThickness(16)

		// Bind MoveToMouse to the mouse's OnPressed.
		// In other words, call MoveToMouse whenever any mouse button is pressed.
		EVENT_ADD(client.mouse_buttons.OnPressed, src, .proc/MoveToMouse)

	proc
		MoveToMouse(button_tracker/buttons, button)
			// Only do this if the right mouse button was pressed.
			if(button == client.MouseRight)
				// Target the mouse's current position.
				move_target = client.mouse_position.WorldPosition()
				// Start the movement loop if not already moving.
				if(!moving)
					StartMoving()

		StartMoving()
			set waitfor = FALSE

			// Be a different color while moving. Because why not.
			color = "aqua"

			// The loop repeats until the destination is reached.
			moving = TRUE
			var vector2/to_mouse, distance
			while((distance = (to_mouse = move_target - CenterPosition()).Magnitude()) > 0)
				PixelSlide(to_mouse * min(1, move_speed / distance))
				move_arrow.SetPoints(CenterPosition(), move_target, z)
				sleep world.tick_lag
			moving = FALSE

			// Reset color when movement stops.
			color = initial(color)
			move_arrow.loc = null
