/* Hold right-click to move toward the mouse.
*/

#include "../Arrow.dm"
#include "PlayerMoveSpeed.dm"

client
	// The right mouse button can only be detected when popup menus are disabled.
	show_popup_menus = FALSE

mob/player
	var
		tmp
			button_timer/mouse_button_timer
			obj/arrow/move_arrow

	Login()
		..()
		move_arrow = new
		move_arrow.color = "red"
		move_arrow.SetThickness(16)

		mouse_button_timer = new(client.mouse_buttons)
		EVENT_ADD(client.mouse_buttons.OnReleased, src, .proc/ClearMoveMarker)
		EVENT_ADD(mouse_button_timer.OnRepeat, src, .proc/MoveTowardMouse)

	proc
		ClearMoveMarker(button_tracker/buttons, button)
			if(button == client.MouseRight)
				move_arrow.loc = null

		// Called every tick while any mouse button is pressed,
		// thanks to the OnRepeat event.
		MoveTowardMouse(button_timer/timer)
			// Check if the right mouse button is being held.
			if(timer.tracker[client.MouseRight])
				// Get a vector from the mob to the mouse.
				var
					vector2/position = CenterPosition()
					vector2/mouse_world_position = client.mouse_position.WorldPosition()
					vector2/to_mouse = mouse_world_position - position
					distance = to_mouse.Magnitude()

				// Step towards the mouse if it's actually in some direction away.
				if(distance)
					// Step towards the mouse at a speed of move_speed.
					// Or, if you're closer than that, just move the rest of the way.
					PixelSlide(to_mouse * (move_speed / distance))

				move_arrow.SetPoints(CenterPosition(), client.mouse_position.WorldPosition(), z)
