/* Tank controls.
	You can turn left and right with D/A.
	You can accelerate forward and backwards with W/S.
	You will slow to a stop if not accelerating.
*/

#include "../AtomForward.dm"
#include "../Velocity.dm"
#include "PlayerLoop.dm"
#include "PlayerMoveInput.dm"

mob/player
	icon_state = "arrow"

	transform = matrix(24/32, 0, 0, 0, 32/32, 0)
	bound_width = 16
	bound_height = 16
	bound_x = 8
	bound_y = 8

	var
		tmp
			turning = 0
			accelerating = 0

	proc
		// Degrees per decisecond of turning.
		TurnRate()
			return 10

		// How fast speed increases when accelerating.
		Acceleration()
			return 5

		// How fast speed decreases when not accelerating.
		Deceleration()
			return 0.25

	UpdateMoveInput(button_tracker/buttons, button)
		..()
		turning = move_input.x // Turn with horizontal move input.
		accelerating = move_input.y // Accelerate with vertical move input.

	PlayerUpdate()
		..()

		// Turn when turning.
		Turn(turning * TurnRate() * PlayerLoop.tick_lag)

		// Reproject velocity onto the forward axis.
		SetVelocity(Forward() * Velocity().Dot(Forward()))

		// This will be how much our velocity changes during this tick.
		var vector2/acceleration = Vector2.Zero

		// Accelerate when accelerating.
		if(accelerating)
			acceleration += Forward() * (accelerating * Acceleration())

		// Decelerate constantly.
		acceleration -= Velocity() * Deceleration()

		// Apply acceleration.
		if(acceleration ~! Vector2.Zero)
			SetVelocity(Velocity() + acceleration * PlayerLoop.tick_lag)
