/* A bullet is a simple projectile that moves from a starting position and at a given velocity.
	As a bonus, the radius can be provided in the constructor too.
*/

#include "../AtomForward.dm"
#include "../Velocity.dm"

obj/bullet
	icon_state = "oval"
	color = "yellow"
	density = TRUE
	mouse_opacity = FALSE
	transform = matrix(8/32, 0, 0, 0, 8/32, 0)

	var
		radius = 4

	New(vector2/position, z, vector2/velocity = Vector2.Zero, radius)
		..()
		if(position && z)
			SetCenterTo(position, z)

		SetVelocity(velocity)

		if(radius != null)
			src.radius = radius

		bound_x = bound_y = 16 - src.radius
		bound_width = bound_height = src.radius * 2
		transform = matrix(src.radius/16, 0, 0, 0, src.radius/16, 0)

	Move()
		. = ..()
		if(!.)
			Destroy()

	// When bumping into something, destroy the bullet.
	Bump(atom/obstacle)
		..()
		Destroy()

	proc
		Destroy()
			set waitfor = FALSE

			// Physically deactivate the bullet.
			SetVelocity(Vector2.Zero)
			density = FALSE

			// Wait a tick for the bullet to visibly hit the wall before disappearing.
			sleep world.tick_lag
			loc = null
