/* A basic top-down shooter demo.
*/
#include "Gun.dm"
#include "../Controls/PlayerLoop.dm"

// Have some premade gun types.
obj/gun
	pistol
		transform = matrix(4/32, 0, 0, 0, 8/32, 22)
		muzzle_distance = 26
		fire_mode = SemiAuto
		fire_rate = 10
		bullet_speed = 32
		spread = 2

	rifle
		transform = matrix(4/32, 0, 0, 0, 24/32, 30)
		muzzle_distance = 42
		fire_mode = Burst
		fire_rate = 10
		shots_per_burst = 3
		bullet_speed = 128
		spread = 3

	smg
		transform = matrix(4/32, 0, 0, 0, 16/32, 26)
		muzzle_distance = 34
		fire_mode = FullAuto
		fire_rate = 10
		bullet_speed = 64
		spread = 10

mob/player
	var
		tmp
			vector2/aim

			obj/gun
				gun

				pistol/pistol = new
				rifle/rifle = new
				smg/smg = new

	New()
		..()
		aim = Vector2.North

	Login()
		..()

		// Initialize the gun. Here you can change the type of gun you spawn with.
		EquipGun(smg)

		// Shooting controls
		EVENT_ADD(client.mouse_buttons.OnPressed, src, .proc/PullTrigger)
		EVENT_ADD(client.mouse_buttons.OnReleased, src, .proc/ReleaseTrigger)

		// Equipment controls
		EVENT_ADD(client.macros.OnPressed, src, .proc/SwitchWeapon)

	// When the mouse moves, aim towards it
	PlayerUpdate()
		..()
		var vector2/to_mouse = client.mouse_position.WorldPosition() - CenterPosition()
		if(to_mouse ~! Vector2.Zero)
			aim = to_mouse.Normalized()
			gun.SetForward(aim)

	proc
		EquipGun(obj/gun/new_gun)
			if(gun)
				vis_contents -= gun
				gun.ReleaseTrigger(src)
			gun = new_gun
			if(gun)
				vis_contents += gun

		// When a button is pressed
		SwitchWeapon(button_tracker/buttons, button)
			switch(button)
				if("1") EquipGun(pistol)
				if("2") EquipGun(smg)
				if("3") EquipGun(rifle)

		// When a mouse button is pressed
		PullTrigger(button_tracker/buttons, button)
			// If the button is the left mouse button
			if(button == client.MouseLeft)
				// If a gun is equipped, pull the trigger
				gun?.PullTrigger(src)

		// When a mouse button is released
		ReleaseTrigger(button_tracker/buttons, button)
			// If the button is the left mouse button
			if(button == client.MouseLeft)
				// If a gun is equipped, release the trigger
				gun?.ReleaseTrigger(src)

